# ORBITADOR

**ORBITADOR** is a software tool for robustness analysis of dynamical systems commanded by differential equations. It implements a formal method to prove formally the stability of time-periodic systems and some other useful features.

## Installation of dependencies

**ORBITADOR**  has some dependencies (like `numpy`, `sympy`, `scipy` and `matplotlib`) which must be installed so that ORBITADOR works correctly.

These dependencies can be installed separately using the commands below:
```bash
pip3 install numpy
pip3 install sympy
pip3 install scipy
sudo apt-get install python3-matplotlib -y
sudo apt-get install python3-tk
```
Or, they can be installed using the `requirements.txt` file in `orbitador` directory:
```bash
python -m pip install -r requirements.txt
```

## Usage
To launch **ORBITADOR**, the user needs to run, in the terminal, the executable file orbitador followed by the name of the input file:
```bash
./orbitador input_system.py
```
For example, to compute the *Brusselator example* which is in the `examples` directory, run:
```bash
./orbitador examples/brusselator.py
```
## Examples
The `examples` directory contains the input files of the examples given in the website of **ORBITADOR**, which allows to reproduce the results. 

### Options
Here some options that can be used with *orbitador* command:
Options  | Details
------------|-------
--show-figures or -s    |     To show figures directly after analysis
--no-save-figures or -n    |     To block the save of figures
--save-results or -r     |    To save results in `.res`  file
