import numpy as np
import sympy as sy

from sympy import sin, cos


class Example:
    states = ["x1", "x2"]

    parameters = {
        "p" : 3,
        
    }

    def differential_system(self):
        return {
            "x1": p*x1 * (1 - x2),
            "x2": p*x2 * (x1 - 1),
        }


    system_config = {
        "dt": 0.0001,
        "initial_gap_epsilon": 0.05,
        "w": 0.0,
        "num_periods": 5,
        "num_system_simulations": 2,
        "auto_period_value": True,
        "period_value": np.nan,
        # If the period value is fixed (auto_period_value==False), give here the value of one period.
        "init_system": [1.2, 1.1],
    }

    system_display = {
        "1D_plot": [["x1"], ["x2"]],  # Select states to show as a function of t
        "2D_plot": [["x1", "x2"]],  # Select two states in each list to show in 2D plot
        ## SOME OPTIONS TO ADD IN 1D PLOTS
        "delta_curve": True,  # To show the curve of delta in green
        "color_depend_on_lambda_sign": False,  # To show the curve of the state according to the sign of lambda (red if lambda>0 and green otherwise)
        "simulations_curves": False,  # To show the curves of the random simulations in blue
        "min_max_tube": False,  # To show the lowest point of the top part of the tube  and the highest point of the bottom part of the tube

        "plot_lambda": True,  # To show the evolution of lambda as a function of t
        "plot_delta": True,  # To show the evolution of delta as a function of t
        "plot_gamma": True,  # To show the evolution of gamma as a function of t
        "step_plot": 1
    }

    def __init__(self, ):
        self.states = self.states
        def_s(self.states)
        try:
            self.parameters = self.parameters
            def_p(self.parameters)
        except AttributeError:
            pass

    def guard_def(self, *states_):
        def_v(self.states, states_)
        if "guard" not in dir(self):
            return None
        else:
            return self.guard()


def def_s(var):
    for i_states in var:
        globals()[i_states] = sy.Symbol(i_states)


def def_v(var, states_):
    i_ = 0
    for i_states in var:
        globals()[i_states] = states_[i_]
        i_ += 1


def def_p(var):
    l_parameters = list(var)
    for i_parameter in l_parameters:
        globals()[i_parameter] = var[i_parameter]
    return globals()
