import matplotlib.pyplot as plot1
import matplotlib.pyplot as plot4
import matplotlib.pyplot as plot3D
import numpy as np
import funcs
from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg


def plot_system_t(sys_orig_, index_state_, wall_top_, wall_bottom_, tubes_, step_plot_, states_name_, i_one_period_,
                  i_period_inclus_, i_max_wall_bottom_, i_min_wall_top_, max_wall_bottom_, min_wall_top_,
                  dt_, tf_, w_, ecart_epsilon_, index_fig_, NodeT_, T_, list_index_sys_lambda_sig, sys_name_, block_plot_,
                  show_sys_orig_with_lambda_sign, show_simul_, show_wall_, show_inter_,
                  save_, show_fig_):
    fig1 = plot1.figure()
    ax1 = plot1.gca()
    plot1.xlabel('t')
    plot1.ylabel(states_name_[index_state_])
    if show_simul_:
        for i_system_tube in range(0, len(tubes_)):
            plot1.plot(T_[:NodeT_:step_plot_], np.array(tubes_)[i_system_tube, :NodeT_:step_plot_, index_state_],
                       color='blue')
    if show_wall_:
        plot1.plot(T_[:NodeT_ - 1:step_plot_], np.array(wall_top_)[:NodeT_ - 1:step_plot_, index_state_], color='green')
        plot1.plot(T_[:NodeT_ - 1:step_plot_], np.array(wall_bottom_)[:NodeT_ - 1:step_plot_, index_state_],
                   color='green')
    if show_sys_orig_with_lambda_sign:
        if list_index_sys_lambda_sig[1]:
            first_color = 'red'
            second_color = 'green'
        else:
            first_color = 'green'
            second_color = 'red'
        for i_cut in range(1, len(list_index_sys_lambda_sig[0])):
            if i_cut % 2 == 1:
                plot1.plot(T_[list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_],
                           np.array(sys_orig_)[
                           list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_,
                           index_state_], color=first_color)
            else:
                plot1.plot(T_[list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_],
                           np.array(sys_orig_)[
                           list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_,
                           index_state_], color=second_color)
    else:
        plot1.plot(T_[:NodeT_:step_plot_], np.array(sys_orig_)[:NodeT_:step_plot_, index_state_], color='red')

    if show_inter_:
        min_wall_tube_bottom_ = min(np.array(wall_bottom_)[:NodeT_ - 1:step_plot_, index_state_])
        max_wall_tube_top_ = max(np.array(wall_top_)[:NodeT_ - 1:step_plot_, index_state_])
        dis_wall_bottom_top = abs(max_wall_tube_top_ - min_wall_tube_bottom_)
        min_wall_tube_bottom_ -= dis_wall_bottom_top * 0.05
        max_wall_tube_top_ += dis_wall_bottom_top * 0.05
        plot1.plot([T_[i_one_period_ * i_period_inclus_], T_[i_one_period_ * i_period_inclus_]],
                   [min_wall_tube_bottom_, max_wall_tube_top_], color='black')
        plot1.plot([T_[i_one_period_ * (i_period_inclus_ + 1)], T_[i_one_period_ * (i_period_inclus_ + 1)]],
                   [min_wall_tube_bottom_, max_wall_tube_top_], color='black')
        plot1.plot(T_[int(i_max_wall_bottom_[index_state_])], max_wall_bottom_[index_state_], 'o', color='gray')
        plot1.plot(T_[int(i_min_wall_top_[index_state_])], min_wall_top_[index_state_], 'o', color='cyan')
    if save_:
        plot1.savefig(
            f'{sys_name_}-{states_name_[index_state_]}-dt=1-on-{round(1 / dt_, 2)}-tf={round(tf_, 2)}-w={w_}-epsilon={ecart_epsilon_}-{index_fig_}.png')
    if show_fig_:
        if block_plot_:
            plot1.show()
        else:
            plot1.show(block=False)


def plot_system_2D(sys_orig_, index_state_1_, index_state_2_, wall_top_, wall_bottom_, tubes_, step_plot_, states_name_,
                   dt_, tf_, w_, ecart_epsilon_, index_fig_, NodeT_,
                   list_index_sys_lambda_sig, sys_name_, block_plot_, show_sys_orig_with_lambda_sign, show_simul_, show_wall_, save_, show_fig_
                   ):
    fig1 = plot1.figure()
    ax1 = plot1.gca()
    plot1.xlabel(states_name_[index_state_1_])
    plot1.ylabel(states_name_[index_state_2_])
    if show_simul_:
        for i_system_tube in range(0, len(tubes_)):
            plot1.plot(np.array(tubes_)[i_system_tube, :NodeT_:step_plot_, index_state_1_],
                       np.array(tubes_)[i_system_tube, :NodeT_:step_plot_, index_state_2_], color='blue')
    if show_wall_:
        plot1.plot(np.array(wall_top_)[:NodeT_ - 1:step_plot_, index_state_1_],
                   np.array(wall_top_)[:NodeT_ - 1:step_plot_, index_state_2_], color='green')
        plot1.plot(np.array(wall_bottom_)[:NodeT_ - 1:step_plot_, index_state_1_],
                   np.array(wall_bottom_)[:NodeT_ - 1:step_plot_, index_state_2_], color='green')

    if show_sys_orig_with_lambda_sign:
        if list_index_sys_lambda_sig[1]:
            first_color = 'red'
            second_color = 'green'
        else:
            first_color = 'green'
            second_color = 'red'
        for i_cut in range(1, len(list_index_sys_lambda_sig[0])):
            if i_cut % 2 == 1:
                plot1.plot(np.array(sys_orig_)[
                           list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_,
                           index_state_1_], np.array(sys_orig_)[
                                            list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][
                                                i_cut]:step_plot_, index_state_1_], color=first_color)
            else:
                plot1.plot(np.array(sys_orig_)[
                           list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_,
                           index_state_1_], np.array(sys_orig_)[
                                            list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][
                                                i_cut]:step_plot_, index_state_2_], color=second_color)
    else:
        plot1.plot(np.array(sys_orig_)[:NodeT_:step_plot_, index_state_1_],
                   np.array(sys_orig_)[:NodeT_:step_plot_, index_state_2_], color='red')

    if save_:
        plot1.savefig(
            f'{sys_name_}-{states_name_[index_state_1_]}-{states_name_[index_state_2_]}-dt=1-on-{round(1 / dt_, 2)}-tf={round(tf_, 2)}-w={w_}-epsilon={ecart_epsilon_}-{index_fig_}.png')
    if show_fig_:
        if block_plot_:
            plot1.show()
        else:
            plot1.show(block=False)


def plot_system_3D(sys_orig_, index_state_1_, index_state_2_, index_state_3_, wall_top_,
                   wall_bottom_, tubes_, step_plot_, states_name_, dt_, tf_, w_, ecart_epsilon_, index_fig_, NodeT_,
                   list_index_sys_lambda_sig, sys_name_, block_plot_, show_sys_orig_with_lambda_sign, show_simul_, show_wall_, save_,
                   show_fig_):
    fig1 = plot3D.figure()
    ax = plot3D.axes(projection='3d')
    ax.set_xlabel(states_name_[index_state_1_])
    ax.set_ylabel(states_name_[index_state_2_])
    ax.set_zlabel(states_name_[index_state_3_])
    if show_simul_:
        for i_system_tube in range(0, len(tubes_)):
            ax.plot3D(np.array(tubes_)[i_system_tube, :NodeT_:step_plot_, index_state_1_],
                      np.array(tubes_)[i_system_tube, :NodeT_:step_plot_, index_state_2_],
                      np.array(tubes_)[i_system_tube, :NodeT_:step_plot_, index_state_3_], color='blue')
    if show_wall_:
        ax.plot3D(np.array(wall_top_)[:NodeT_ - 1:step_plot_, index_state_1_],
                  np.array(wall_top_)[:NodeT_ - 1:step_plot_, index_state_2_],
                  np.array(wall_top_)[:NodeT_ - 1:step_plot_, index_state_3_], color='green')
        ax.plot3D(np.array(wall_bottom_)[:NodeT_ - 1:step_plot_, index_state_1_],
                  np.array(wall_bottom_)[:NodeT_ - 1:step_plot_, index_state_2_],
                  np.array(wall_bottom_)[:NodeT_ - 1:step_plot_, index_state_3_], color='green')
    # print("sys_orig_1=", sys_orig_1)
    if show_sys_orig_with_lambda_sign:
        if list_index_sys_lambda_sig[1]:
            first_color = 'red'
            second_color = 'green'
        else:
            first_color = 'green'
            second_color = 'red'
        for i_cut in range(1, len(list_index_sys_lambda_sig[0])):
            if i_cut % 2 == 1:
                ax.plot3D(np.array(sys_orig_)[
                          list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_,
                          index_state_1_],
                          np.array(sys_orig_)[
                          list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_,
                          index_state_2_],
                          np.array(sys_orig_)[
                          list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_,
                          index_state_3_],
                          color=first_color)
            else:
                ax.plot3D(np.array(sys_orig_)[
                          list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_,
                          index_state_1_],
                          np.array(sys_orig_)[
                          list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_,
                          index_state_2_],
                          np.array(sys_orig_)[
                          list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_,
                          index_state_3_],
                          color=second_color)
    else:
        ax.plot3D(np.array(sys_orig_)[:NodeT_:step_plot_, index_state_1_],
                  np.array(sys_orig_)[:NodeT_:step_plot_, index_state_2_],
                  np.array(sys_orig_)[:NodeT_:step_plot_, index_state_3_], color='red')
    ax.plot3D(np.array(sys_orig_)[0, index_state_1_], np.array(sys_orig_)[0, index_state_2_],
              np.array(sys_orig_)[0, index_state_3_], 'o', color='black')
    if save_:
        plot3D.savefig(
            f'{sys_name_}-3D-{states_name_[index_state_1_]}-{states_name_[index_state_2_]}-{states_name_[index_state_3_]}-dt=1-on-{round(1 / dt_, 2)}-tf={round(tf_, 2)}-w={w_}-epsilon={ecart_epsilon_}-{index_fig_}.png')
    if show_fig_:
        if block_plot_:
            plot3D.show()
        else:
            plot3D.show(block=False)


def plot_system_3D_e(sys_orig_1, sys_orig_2, sys_orig_3, index_state_1_, index_state_2_, index_state_3_, wall_top_,
                     wall_bottom_, tubes_, step_plot_, states_name_, dt_, tf_, w_, ecart_epsilon_, index_fig_, NodeT_,
                     list_index_sys_lambda_sig, sys_name_, block_plot_, show_sys_orig_with_lambda_sign, show_simul_, show_wall_, save_,
                     show_fig_):
    fig1 = plot3D.figure()
    ax = plot3D.axes(projection='3d')
    # ax.set_xlabel(states_name[index_state_1_])
    # ax.set_ylabel(states_name[index_state_2_])
    # ax.set_zlabel(states_name[index_state_3_])

    ax.set_xlabel(r'x')
    ax.set_ylabel(r'y')
    ax.set_zlabel(r'z')
    if show_simul_:
        for i_system_tube in range(0, len(tubes_)):
            ax.plot3D(np.array(tubes_)[i_system_tube, :NodeT_:step_plot_, index_state_1_],
                      np.array(tubes_)[i_system_tube, :NodeT_:step_plot_, index_state_2_],
                      np.array(tubes_)[i_system_tube, :NodeT_:step_plot_, index_state_3_], color='blue')
    if show_wall_:
        ax.plot3D(np.array(wall_top_)[:NodeT_ - 1:step_plot_, index_state_1_],
                  np.array(wall_top_)[:NodeT_ - 1:step_plot_, index_state_2_],
                  np.array(wall_top_)[:NodeT_ - 1:step_plot_, index_state_3_], color='green')
        ax.plot3D(np.array(wall_bottom_)[:NodeT_ - 1:step_plot_, index_state_1_],
                  np.array(wall_bottom_)[:NodeT_ - 1:step_plot_, index_state_2_],
                  np.array(wall_bottom_)[:NodeT_ - 1:step_plot_, index_state_3_], color='green')
    # print("sys_orig_1=", sys_orig_1)
    if show_sys_orig_with_lambda_sign:
        if list_index_sys_lambda_sig[1]:
            first_color = 'red'
            second_color = 'green'
        else:
            first_color = 'green'
            second_color = 'red'
        for i_cut in range(1, len(list_index_sys_lambda_sig[0])):
            if i_cut % 2 == 1:
                ax.plot3D(np.array(sys_orig_1)[
                          list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_],
                          np.array(sys_orig_2)[
                          list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_],
                          np.array(sys_orig_3)[
                          list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_],
                          color=first_color)
            else:
                ax.plot3D(np.array(sys_orig_1)[
                          list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_],
                          np.array(sys_orig_2)[
                          list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_],
                          np.array(sys_orig_3)[
                          list_index_sys_lambda_sig[0][i_cut - 1]:list_index_sys_lambda_sig[0][i_cut]:step_plot_],
                          color=second_color)
    else:
        ax.plot3D(np.array(sys_orig_1)[:NodeT_:step_plot_], np.array(sys_orig_2)[:NodeT_:step_plot_],
                  np.array(sys_orig_3)[:NodeT_:step_plot_], color='red')
    ax.plot3D(np.array(sys_orig_1)[0], np.array(sys_orig_2)[0], np.array(sys_orig_3)[0], 'o', color='black')
    # ax.set_xlim3d(-1.1, 1.1)
    # ax.set_ylim3d(-1.1, 1.1)
    # ax.set_zlim3d(-0.2, 0.2)
    if save_:
        plot3D.savefig(
            f'{sys_name_}-3D-{states_name_[index_state_1_]}-{states_name_[index_state_2_]}-{states_name_[index_state_3_]}-dt=1-on-{round(1 / dt_, 2)}-tf={round(tf_, 2)}-w={w_}-epsilon={ecart_epsilon_}-{index_fig_}.png')
    if show_fig_:
        if block_plot_:
            plot3D.show()
        else:
            plot3D.show(block=False)


def plot_simulation(simul_, simul_name_, T_, step_plot_, dt_, tf_, w_, ecart_epsilon_, index_fig_, sys_name_, block_plot_, save_, show_fig_):
    fig4 = plot4.figure()
    ax4 = plot4.gca()
    plot4.xlabel('t')
    plot4.ylabel(simul_name_)
    len_simul_ = len(simul_)
    plot4.plot(T_[:len_simul_:step_plot_], simul_[:len_simul_:step_plot_], color='red')
    if save_:
        plot4.savefig(
            f'{sys_name_}-{simul_name_}-dt=1-on-{round(1 / dt_, 2)}-tf={round(tf_, 2)}-w={w_}-epsilon={ecart_epsilon_}-{index_fig_}.png')
    if show_fig_:
        if block_plot_:
            plot4.show()
        else:
            plot4.show(block=False)
    # plot4.clf()


def display_plots(system_orig_, all_lambda_, all_gamma_, all_delta_, wall_tube_top_, wall_tube_bottom_, NodeT_, dt_,
                  tf_, w_, ecart_epsilon_, length_system_, system_equations_, guard_equations_, reset_equations_,
                  init_system_, num_system_simu_, i_period_inclus_, i_one_period_, states_name_, index_fig_, sys_dis_,
                  i_min_wall_top_, i_max_wall_bottom_, min_wall_top_, max_wall_bottom_, sys_name_, show_figures_, save_figures_):
    show_delta = sys_dis_["delta_curve"]
    show_color_sign_lambda = sys_dis_["color_depend_on_lambda_sign"]
    show_simulations = sys_dis_["simulations_curves"]
    min_max_tube = sys_dis_["min_max_tube"]
    step_plot = sys_dis_["step_plot"]
    T = np.linspace(0, tf_, NodeT_)
    num_plots = 0
    block_plot = False
    try:
        sys_dis_["1D_plot"]
    except KeyError:
        pass
    else:
        num_plots += len(sys_dis_["1D_plot"])

    try:
        sys_dis_["2D_plot"]
    except KeyError:
        pass
    else:
        num_plots += len(sys_dis_["2D_plot"])

    try:
        sys_dis_["3D_plot"]
    except KeyError:
        pass
    else:
        num_plots += len(sys_dis_["3D_plot"])
    try:
        sys_dis_["plot_lambda"]
    except KeyError:
        pass
    else:
        if sys_dis_["plot_lambda"]:
            num_plots += 1
    try:
        sys_dis_["plot_gamma"]
    except KeyError:
        pass
    else:
        if sys_dis_["plot_gamma"] and w_ > 0:
            num_plots += 1
    try:
        sys_dis_["plot_delta"]
    except KeyError:
        pass
    else:
        if sys_dis_["plot_delta"]:
            num_plots += 1

    if show_simulations:
        system_simulations = funcs.system_tubes(NodeT_, length_system_, system_equations_, init_system_,
                                                num_system_simu_, guard_equations_, reset_equations_, w_,
                                                ecart_epsilon_, dt_)
    else:
        system_simulations = []
    if show_color_sign_lambda:
        list_index_sys_lam_sg_change = funcs.index_sys_lambda_sign_change(system_orig_, all_lambda_)
    else:
        list_index_sys_lam_sg_change = []
    try:
        selected_1D_plot = sys_dis_["1D_plot"]
    except KeyError:
        pass
    else:
        for i_states_ in range(0, len(selected_1D_plot)):
            num_plots -= 1
            if num_plots == 0:
                block_plot = True
            index_state = states_name_.index(selected_1D_plot[i_states_][0])
            plot_system_t(system_orig_, index_state, wall_tube_top_, wall_tube_bottom_, system_simulations, step_plot,
                          states_name_, i_one_period_, i_period_inclus_, i_max_wall_bottom_, i_min_wall_top_,
                          max_wall_bottom_, min_wall_top_,
                          dt_, tf_, w_, ecart_epsilon_, index_fig_, NodeT_, T, list_index_sys_lam_sg_change, sys_name_, block_plot,
                          show_sys_orig_with_lambda_sign=show_color_sign_lambda, show_simul_=show_simulations,
                          show_wall_=show_delta, show_inter_=min_max_tube, save_=save_figures_, show_fig_=show_figures_)
    try:
        selected_2D_plot = sys_dis_["2D_plot"]
    except KeyError:
        pass
    else:
        for i_states_ in range(0, len(selected_2D_plot)):
            num_plots -= 1
            if num_plots == 0:
                block_plot = True
            index_state1 = states_name_.index(selected_2D_plot[i_states_][0])
            index_state2 = states_name_.index(selected_2D_plot[i_states_][1])
            plot_system_2D(system_orig_, index_state1, index_state2, wall_tube_top_, wall_tube_bottom_,
                           system_simulations, step_plot, states_name_, dt_, tf_, w_, ecart_epsilon_, index_fig_, NodeT_,
                           list_index_sys_lam_sg_change, sys_name_, block_plot, show_sys_orig_with_lambda_sign=show_color_sign_lambda,
                           show_simul_=show_simulations, show_wall_=False, save_=save_figures_, show_fig_=show_figures_)
    try:
        selected_3D_plot = sys_dis_["3D_plot"]
    except KeyError:
        pass
    else:
        for i_states_ in range(0, len(selected_3D_plot)):
            num_plots -= 1
            if num_plots == 0:
                block_plot = True
            index_state1 = states_name_.index(selected_3D_plot[i_states_][0])
            index_state2 = states_name_.index(selected_3D_plot[i_states_][1])
            index_state3 = states_name_.index(selected_3D_plot[i_states_][2])
            plot_system_3D(system_orig_, index_state1, index_state2, index_state3,
                           wall_tube_top_, wall_tube_bottom_, system_simulations, step_plot, states_name_, dt_, tf_, w_,
                           ecart_epsilon_,
                           index_fig_, NodeT_, list_index_sys_lam_sg_change, sys_name_, block_plot,
                           show_sys_orig_with_lambda_sign=show_color_sign_lambda, show_simul_=show_simulations,
                           show_wall_=False, save_=save_figures_, show_fig_=show_figures_)
    try:
        sys_dis_["plot_lambda"]
    except KeyError:
        pass
    else:
        if sys_dis_["plot_lambda"]:
            num_plots -= 1
            if num_plots == 0:
                block_plot = True
            plot_simulation(all_lambda_, "lambda", T, step_plot, dt_, tf_, w_, ecart_epsilon_, index_fig_, sys_name_, block_plot, save_=save_figures_,
                            show_fig_=show_figures_)
    try:
        sys_dis_["plot_gamma"]
    except KeyError:
        pass
    else:
        if sys_dis_["plot_gamma"] and w_ > 0:
            num_plots -= 1
            if num_plots == 0:
                block_plot = True
            plot_simulation(all_gamma_, "gamma", T, step_plot, dt_, tf_, w_, ecart_epsilon_, index_fig_, sys_name_, block_plot, save_=save_figures_,
                            show_fig_=show_figures_)
    try:
        sys_dis_["plot_delta"]
    except KeyError:
        pass
    else:
        if sys_dis_["plot_delta"]:
            num_plots -= 1
            if num_plots == 0:
                block_plot = True
            plot_simulation(all_delta_, "delta", T, step_plot, dt_, tf_, w_, ecart_epsilon_, index_fig_, sys_name_, block_plot, save_=save_figures_,
                            show_fig_=show_figures_)
